#include <stdio.h>
#include <stdlib.h>

#include "Queue.h"

// Check if a queue is empty
BOOL isEmpty(Queue *q)
{
	if (q->size == 0)
		return TRUE;
	else
		return FALSE;
}

// Create a queue
Queue *createQueue(void)
{
	Queue *newQueue = (Queue *) malloc(sizeof(Queue ));

	if (newQueue == NULL)
		ERROR("Memory Allocation Error!!!");

	newQueue->size = 0;
	newQueue->tail = NULL;
	newQueue->head = NULL;

	return newQueue;
}

// Delete a queue and its contents
void deleteQueue(Queue *q)
{
	QNode *curNode = q->tail;
	QNode *nextNode = NULL;
	
	while (curNode != NULL) {
		nextNode = curNode->next;
		free(curNode);		
		curNode = nextNode;
	}
	free(q);
}

// Create a queue node
QNode *createQNode(Type value)
{
	QNode *newNode = (QNode *) malloc(sizeof(QNode));
	if (newNode == NULL)
		ERROR("Memory Allocation Error!!!");

	newNode->next=NULL;
	newNode->data = value;

	return newNode;
}

// Enqueue a value in the queue
void enqueue(Queue *q, Type value)
{
	QNode *newNode = createQNode(value);

	if(isEmpty(q) == TRUE){
		q->tail = newNode;
		q->head = newNode;		
	}
	else{
		q->head->next = newNode;
		q->head = newNode;
	}

	q->size++;
}

// Dequeue an element from the queue and return its value
Type dequeue(Queue *q)
{
	int result = -1;

	if(isEmpty(q) == FALSE){
		result = q->tail->data;
		if(q->size==1){
			free(q->tail);
			q->tail = NULL;
			q->head = NULL;
		}
		else{
			QNode *tmp = q->tail;
			q->tail = q->tail->next;
			free(tmp);
		}
		q->size--;
	}
#ifdef _DEBUG
	else {
		WARNING("Tried to dequeue data from an empty Queue!!!");
	}
#endif // _DEBUG
	
	return result;
}

// Print the contents of the queue
void printQueue(Queue *q)
{
	QNode *tmp = q->tail;
	int i = 0;
	for(i = 0; i < q->size; ++i, tmp = tmp->next)
		fprintf(stdout, TYPE_MODIFIER" ", tmp->data);
	printf("\n");
}

// Print the tail of the queue
void printTail(Queue *q)
{
	fprintf(stdout, "First Node: "TYPE_MODIFIER"\n", q->tail->data);
}

// Print the head of the queue
void printHead(Queue *q)
{
	fprintf(stdout, "Last Node: "TYPE_MODIFIER"\n", q->head->data);
}
