#ifndef __QUEUE_H__
#define __QUEUE_H__

#include "defns.h"


typedef struct _QNode {
 	Type data;
	struct _QNode *next;
} QNode;

typedef QNode *QNodePtr;

typedef struct _Queue {
	int size;
	QNode *tail;
	QNode *head;
} Queue;

typedef Queue *QueuePtr;

// Check if the queue is empty
BOOL isEmpty(Queue *q);
// Create and initialize a queue
Queue *createQueue(void);
// Create and initialize a queue node
QNode *createQNode(Type value);
// Enqueue an element in the queue
void enqueue(Queue *q, Type value);
// Dequeue an element from the queue and return its value
Type dequeue(Queue *q);
// Delete the queue and its contents
void deleteQueue(Queue *q);
// Print the contents of the queue
void printQueue(Queue *q);
// Print the tail of the queue
void printTail(Queue *q);
// Print the head of the queue
void printHead(Queue *q);

#endif // __QUEUE_H__